<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfGetGeoZoneEventResult ArrayType
 * @subpackage Arrays
 */
class ArrayOfGetGeoZoneEventResult extends AbstractStructArrayBase
{
    /**
     * The GetGeoZoneEventResult
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\GetGeoZoneEventResult[]
     */
    public $GetGeoZoneEventResult;
    /**
     * Constructor method for ArrayOfGetGeoZoneEventResult
     * @uses ArrayOfGetGeoZoneEventResult::setGetGeoZoneEventResult()
     * @param \StructType\GetGeoZoneEventResult[] $getGeoZoneEventResult
     */
    public function __construct(array $getGeoZoneEventResult = array())
    {
        $this
            ->setGetGeoZoneEventResult($getGeoZoneEventResult);
    }
    /**
     * Get GetGeoZoneEventResult value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\GetGeoZoneEventResult[]|null
     */
    public function getGetGeoZoneEventResult()
    {
        return isset($this->GetGeoZoneEventResult) ? $this->GetGeoZoneEventResult : null;
    }
    /**
     * This method is responsible for validating the values passed to the setGetGeoZoneEventResult method
     * This method is willingly generated in order to preserve the one-line inline validation within the setGetGeoZoneEventResult method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateGetGeoZoneEventResultForArrayConstraintsFromSetGetGeoZoneEventResult(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfGetGeoZoneEventResultGetGeoZoneEventResultItem) {
            // validation for constraint: itemType
            if (!$arrayOfGetGeoZoneEventResultGetGeoZoneEventResultItem instanceof \StructType\GetGeoZoneEventResult) {
                $invalidValues[] = is_object($arrayOfGetGeoZoneEventResultGetGeoZoneEventResultItem) ? get_class($arrayOfGetGeoZoneEventResultGetGeoZoneEventResultItem) : sprintf('%s(%s)', gettype($arrayOfGetGeoZoneEventResultGetGeoZoneEventResultItem), var_export($arrayOfGetGeoZoneEventResultGetGeoZoneEventResultItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The GetGeoZoneEventResult property can only contain items of type \StructType\GetGeoZoneEventResult, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set GetGeoZoneEventResult value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\GetGeoZoneEventResult[] $getGeoZoneEventResult
     * @return \ArrayType\ArrayOfGetGeoZoneEventResult
     */
    public function setGetGeoZoneEventResult(array $getGeoZoneEventResult = array())
    {
        // validation for constraint: array
        if ('' !== ($getGeoZoneEventResultArrayErrorMessage = self::validateGetGeoZoneEventResultForArrayConstraintsFromSetGetGeoZoneEventResult($getGeoZoneEventResult))) {
            throw new \InvalidArgumentException($getGeoZoneEventResultArrayErrorMessage, __LINE__);
        }
        if (is_null($getGeoZoneEventResult) || (is_array($getGeoZoneEventResult) && empty($getGeoZoneEventResult))) {
            unset($this->GetGeoZoneEventResult);
        } else {
            $this->GetGeoZoneEventResult = $getGeoZoneEventResult;
        }
        return $this;
    }
    /**
     * Add item to GetGeoZoneEventResult value
     * @throws \InvalidArgumentException
     * @param \StructType\GetGeoZoneEventResult $item
     * @return \ArrayType\ArrayOfGetGeoZoneEventResult
     */
    public function addToGetGeoZoneEventResult(\StructType\GetGeoZoneEventResult $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\GetGeoZoneEventResult) {
            throw new \InvalidArgumentException(sprintf('The GetGeoZoneEventResult property can only contain items of type \StructType\GetGeoZoneEventResult, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->GetGeoZoneEventResult[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\GetGeoZoneEventResult|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\GetGeoZoneEventResult|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\GetGeoZoneEventResult|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\GetGeoZoneEventResult|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\GetGeoZoneEventResult|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string GetGeoZoneEventResult
     */
    public function getAttributeName()
    {
        return 'GetGeoZoneEventResult';
    }
}
